unit UMain_01;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ImgList, ExtCtrls, GameEngine, ComCtrls;

Const
     sSize = 40 ;  

type
  TfrmMain = class(TForm)
    SkinImage: TImage;
    Timer1: TTimer;
    Player1Images: TImageList;
    lbPlayer1: TLabel;
    lbPlayer2: TLabel;
    lbScore1: TLabel;
    lbScore2: TLabel;
    lbRoundCount: TLabel;
    lbNuls: TLabel;
    Player2Images: TImageList;
    cmdNew: TLabel;
    cmdReset: TLabel;
    cmdOptions: TLabel;
    cmdExit: TLabel;
    GrilleImage: TImage;
    lbCurrentPosition: TLabel;
    WinAnimateTimer: TTimer;
    GameEngine1: TGameEngine;
    Shape1: TShape;
    procedure EnterColor(Sender: TObject);
    procedure LeavColor(Sender: TObject);
    procedure cmdExitClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure lbPlayer1DblClick(Sender: TObject);
    procedure GrilleImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GrilleImageClick(Sender: TObject);
    procedure GameEngine1GameWiner(Sender: TObject);
    procedure GameEngine1GameNull(Sender: TObject);
    procedure GameEngine1Play(Sender: TObject);
    procedure GameEngine1Initialisation(Sender: TObject);
    procedure GameEngine1OverFlow(Sender: TObject);
    procedure GameEngine1NewGame(Sender: TObject);
    procedure cmdResetClick(Sender: TObject);
    procedure cmdNewClick(Sender: TObject);
    procedure GameEngine1PlayerChage(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure WinAnimateTimerTimer(Sender: TObject);
    procedure cmdOptionsClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Procedure DisplayGameInfos;
  end;

var
  frmMain: TfrmMain;
  Fond, EmptyGrille, Buffer, Pion : TBitmap;
  CurrentPosition : TPosition;
  PlayPosition : TPoint;
  idx, sIDX,  MaxWidth, MaxHeight, player : Integer;
  successPos : TWantedPositions;
implementation

uses  Math, UParam;

{$R *.dfm}
//------Fonction Graphiques-----------------------------------------------------

Procedure MakeToBuffer(bmpBack : TBitmap; Sprite : TBitmap; NewPosition : TPoint; OldPosition : TPoint;Out tmpBmp : TBitmap);
Var
  OldRect : TRect;
Begin
  Sprite.transparent := True;
  Sprite.TransparentColor := Sprite.Canvas.Pixels[1, 1];
  If Not Assigned(tmpBmp) Then tmpBmp := TBitmap.Create;
  tmpBmp.Assign(bmpBack);
  OldRect := rect(OldPosition.x, OldPosition.y, OldPosition.x + Sprite.Width, OldPosition.y + Sprite.Height);
  tmpBmp.Canvas.CopyRect(OldRect, bmpBack.canvas, OldRect);
  tmpBmp.Canvas.Draw(NewPosition.x, NewPosition.y, Sprite);
End;


Function EngineToGraphXY( x,y : Integer): TPoint;
 Var p:TPoint;
 begin
   if x = 1 then P.X := 1 else
    begin
      P.X := ((X-1) * sSize)+ X;
    end;
   P.Y := MaxHeight - ((Y * sSize)+Y) ;
   Result := P;
 End;

Function GraphToEngineXY (x,y : Integer): TPosition;
   Var p: TPosition;
       w, h : integer;
  Begin
    SetRoundMode(rmUp	);
    w := Round((x) div sSize) ;
    P.X := w+1;
    h := Round(y div sSize) ;
    P.Y := MaxY - h;
    if P.X > MaxX then P.X := MaxX;
    If P.Y > MaxY Then P.Y := MaxY;
    Result := P;
  End;

//------------------------------------------------------------------------------


Procedure TfrmMain.DisplayGameInfos;
   Begin
    lbPlayer1.Caption :=  GameEngine1.Player1Name;
    lbPlayer2.Caption :=  GameEngine1.Player2Name;
    lbRoundCount.Caption := IntToStr(GameEngine1.GetRoundCount);
    lbNuls.Caption := IntToStr(GameEngine1.GetGameNullCount);
    lbScore1.Caption := intToStr(GameEngine1.GatPlayerScore(1));
    lbScore2.Caption := intToStr(GameEngine1.GatPlayerScore(2));
    if GameEngine1.GetCurrentPlayerID = P1 then Shape1.Top := 45 else Shape1.Top := 77; 
   End;

procedure TfrmMain.EnterColor(Sender: TObject);
begin
 (Sender as TLabel).Font.Color := clRed;
end;

procedure TfrmMain.LeavColor(Sender: TObject);
begin
(Sender as TLabel).Font.Color := clBlack;
end;

procedure TfrmMain.cmdExitClick(Sender: TObject);
begin
Close;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
if MessageDlg('Voulez-vous quitter le jeux ?',mtConfirmation ,[mbYes,mbNo] ,0)= mrYes then
 begin
   CanClose := True;
 end else
    begin
       CanClose := False;
    end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  
  EmptyGrille := TBitmap.Create;
  EmptyGrille.Assign(GrilleImage.Picture.Bitmap);
  Fond := TBitmap.Create;
  Fond.Assign(EmptyGrille);
  Buffer := TBitmap.Create;
  Pion := TBitmap.Create;
  Pion.Width := 40;
  Pion.Height := 40;
  idx:= 0; 
  MaxWidth := GrilleImage.Width ;
  MaxHeight:= GrilleImage.Height;
  CurrentPosition.X := 40;
  CurrentPosition.Y := 40;

  GameEngine1.InitGame;
end;

procedure TfrmMain.Timer1Timer(Sender: TObject);

begin
  Timer1.Interval := 25;
  Pion.Canvas.FillRect(rect(0, 0, Pion.Width, Pion.Height));
  if player = P1 Then Player1Images.GetBitmap(idx, Pion) else
  Player2Images.GetBitmap(idx, Pion);
  MakeToBuffer(Fond, Pion, PlayPosition, PlayPosition,Buffer );
  Fond.Assign(Buffer);
  GrilleImage.Picture.Bitmap.Assign(Buffer);
  Inc(idx);
  if idx > 3 then
    Begin
     timer1.Enabled := False;
    End;
    
end;               

procedure TfrmMain.lbPlayer1DblClick(Sender: TObject);
begin
timer1.Enabled := Not timer1.Enabled  ;
end;

procedure TfrmMain.GrilleImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);

begin
CurrentPosition := GraphToEngineXY(x,y);
lbCurrentPosition.Caption := 'X = '+IntToStr(CurrentPosition.X) +' , Y = '+IntToStr(CurrentPosition.Y);
end;

procedure TfrmMain.GrilleImageClick(Sender: TObject);
begin
 GameEngine1.Play(CurrentPosition.X);
end;

procedure TfrmMain.GameEngine1GameWiner(Sender: TObject);
begin
successPos := GameEngine1.GetSuccessPoints;
ShowMessage('Bravo : '+ GameEngine1.GetCurrentPlayerName+' ! ');
DisplayGameInfos;
idx := 0 ;
WinAnimateTimer.Enabled := True;
cmdNew.Enabled := True;
end;

procedure TfrmMain.GameEngine1GameNull(Sender: TObject);
begin
ShowMessage('Match nul ! ');
DisplayGameInfos;
cmdNew.Enabled := True;

end;

procedure TfrmMain.GameEngine1Play(Sender: TObject);
 var
    p : TPoint;
    lP :TPosition;

begin
 lP := GameEngine1.GetLastPosition;
 P := EngineToGraphXY(lp.X, lp.Y);
 PlayPosition.X := P.X;
 PlayPosition.Y := P.Y ;
 idx := 0;
 player := GameEngine1.GetCurrentPlayerID;
 timer1.Enabled := true;
 DisplayGameInfos;
end;

procedure TfrmMain.GameEngine1Initialisation(Sender: TObject);
begin

 GameEngine1.NewGame;

end;

procedure TfrmMain.GameEngine1OverFlow(Sender: TObject);
begin
ShowMessage('C''est satur !!!');
end;

procedure TfrmMain.GameEngine1NewGame(Sender: TObject);
begin
WinAnimateTimer.Enabled := False;
Fond.Assign(EmptyGrille);
GrilleImage.Picture.Bitmap.Assign(Fond);

DisplayGameInfos;
cmdNew.Enabled := False;
end;

procedure TfrmMain.cmdResetClick(Sender: TObject);
begin
GameEngine1.InitGame;
end;

procedure TfrmMain.cmdNewClick(Sender: TObject);
begin
GameEngine1.NewGame;
end;

procedure TfrmMain.GameEngine1PlayerChage(Sender: TObject);
begin
//player := GameEngine1.GetCurrentPlayerID;
DisplayGameInfos;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
 Fond.Free;
 Buffer.Free;
 EmptyGrille.Free;
 Pion.Free;
end;

procedure TfrmMain.WinAnimateTimerTimer(Sender: TObject);
var
    tmp : TPosition;
   AniPos : TPoint;
begin

  Pion.Canvas.FillRect(rect(0, 0, Pion.Width, Pion.Height));
  if player = P1 Then Player1Images.GetBitmap(idx, Pion) else
  Player2Images.GetBitmap(idx, Pion);
  for sIDX := 1 to LinePoints do
    begin
      tmp := successPos[sIDX];
      AniPos := EngineToGraphXY(tmp.X,tmp.Y);
      MakeToBuffer(Fond, Pion, AniPos, AniPos,Buffer );
      Fond.Assign(Buffer);
      GrilleImage.Picture.Bitmap.Assign(Buffer);
    end;
    Inc(idx);
  if idx > 3 Then idx := 0;
end;

procedure TfrmMain.cmdOptionsClick(Sender: TObject);
begin
frmParam.ShowModal;
end;

end.
